#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 White
#property indicator_color2 SteelBlue
#property indicator_color3 Crimson

extern int period = 50;
extern bool alert=true;

bool buy=true;
bool sell=true;

int G_ma_method_80 = MODE_LWMA;
int G_applied_price_84 = PRICE_CLOSE;
double G_ibuf_88[];
double G_ibuf_92[];
double G_ibuf_96[];
double Gda_100[];

int init() {
   IndicatorBuffers(3);
   SetIndexBuffer(1, G_ibuf_88);
   SetIndexBuffer(2, G_ibuf_92);
   SetIndexBuffer(0, G_ibuf_96);
   ArraySetAsSeries(G_ibuf_96, TRUE);
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_DASHDOT, 4);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_DASHDOT, 4);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_DASHDOT, 4);
   IndicatorShortName("Trend Lord");
   return (0);
}

int deinit() {
   return (0);
}

double WMA(int Ai_0, int A_period_4) {
   return (iMA(NULL, 0, A_period_4, 0, G_ma_method_80, G_applied_price_84, Ai_0));
}

int start() {
   double Lda_16[];
   double Lda_20[];
   int ind_counted_0 = IndicatorCounted();
   if (ind_counted_0 < 0) return (-1);
   int Li_4 = 0;
   int period_8 = MathSqrt(period);
   int Li_12 = Bars - ind_counted_0 + period + 1;
   if (Li_12 > Bars) Li_12 = Bars;
   ArrayResize(Lda_16, Li_12);
   ArraySetAsSeries(Lda_16, TRUE);
   ArrayResize(Lda_20, Li_12);
   ArraySetAsSeries(Lda_20, TRUE);
   for (Li_4 = 0; Li_4 < Li_12; Li_4++) Lda_16[Li_4] = 2.0 * WMA(Li_4, period / 1) - WMA(Li_4, period);
   for (Li_4 = 0; Li_4 < Li_12 - period; Li_4++) G_ibuf_96[Li_4] = iMAOnArray(Lda_16, 0, period_8, 0, G_ma_method_80, Li_4);
   for (Li_4 = Li_12 - period; Li_4 >= 0; Li_4--) {
      Lda_20[Li_4] = Lda_20[Li_4 + 1];
      if (G_ibuf_96[Li_4] > G_ibuf_96[Li_4 + 1]) Lda_20[Li_4] = 1;
      if (G_ibuf_96[Li_4] < G_ibuf_96[Li_4 + 1]) Lda_20[Li_4] = -1;
      if (Lda_20[Li_4] > 0.0) {
         G_ibuf_88[Li_4] = G_ibuf_96[Li_4];
         if (Lda_20[Li_4 + 1] < 0.0) G_ibuf_88[Li_4 + 1] = G_ibuf_96[Li_4 + 1];
         G_ibuf_92[Li_4] = EMPTY_VALUE;
         if(alert==true&&buy==true)
            {
               Alert(" BUY   - "+Symbol());
               buy=false;
               sell=true;
            }
            
      } else {
         if (Lda_20[Li_4] < 0.0) {
            G_ibuf_92[Li_4] = G_ibuf_96[Li_4];
            if (Lda_20[Li_4 + 1] > 0.0) G_ibuf_92[Li_4 + 1] = G_ibuf_96[Li_4 + 1];
            G_ibuf_88[Li_4] = EMPTY_VALUE;
          if(alert==true&&sell==true)
            {
               Alert(" SELL   - "+Symbol());
               sell=false;
               buy=true;
            }
         }
      }
      Gda_100[Li_4] = Lda_20[Li_4];
   }
   return (0);
}
